<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/Chain.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Chain_8hpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Chain.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __CMDRSChain_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __CMDRSChain_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLISTITEM.html">    7</a></span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;{</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">   11</a></span>&#160;    T *<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>; </div><div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">   13</a></span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a> *<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLISTITEM.html#a48983e4559b7865ad04ba0b23724259c">   16</a></span>&#160;    <span class="keyword">inline</span> <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a>() { this-&gt;pNext = NULL; }</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;};</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html">   33</a></span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">public</span>:                         </div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">   37</a></span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a> *<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;        </div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">   39</a></span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a> *<a class="code" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    </div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html#a6a8536f2cb62714624e8a1ae2c021191">   42</a></span>&#160;    <span class="keyword">inline</span> <a class="code" href="classCMDRSCHAINEDLIST.html#a6a8536f2cb62714624e8a1ae2c021191">CMDRSCHAINEDLIST</a>() { this-&gt;pFirst = NULL; this-&gt;pCurrentItem = NULL; }</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">AddItem</a>(T *inpt);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">NextCurrent</a>();</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;};</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#define CMDRSCHAIN_ENUMERATE(T, list, func) CMDRSCHAINEDLISTITEM&lt;T&gt; *pCurr = list.pFirst; while (pCurr != NULL) { func(pCurr-&gt;Obj); pCurr = pCurr-&gt;pNext; }</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">// This function appends element into chain.</span></div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">   61</a></span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">CMDRSCHAINEDLIST&lt;T&gt;::AddItem</a>(T *t)</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;{</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a> *pCurr = this-&gt;pFirst;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span> (pCurr == NULL)</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        this-&gt;pFirst = <span class="keyword">new</span> <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a>();</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        this-&gt;pCurrentItem = this-&gt;pFirst;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        pCurr = this-&gt;pFirst;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    {</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">while</span> (pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a> != NULL)</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a> = <span class="keyword">new</span> <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;T&gt;</a>();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    }</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a> = NULL;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a> = t;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">// This function move the current item to the next in the chain.</span></div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">   85</a></span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">CMDRSCHAINEDLIST&lt;T&gt;::NextCurrent</a>()</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;{</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordflow">if</span> (this-&gt;pFirst == NULL)</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    this-&gt;pCurrentItem = this-&gt;pCurrentItem-&gt;pNext;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">if</span> (this-&gt;pCurrentItem == NULL)</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        this-&gt;pCurrentItem = this-&gt;pFirst;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordflow">return</span>;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;}</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classCMDRSCHAINEDLIST_html_a7c95325c818d2e63d6ccf0b7f5250103"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">CMDRSCHAINEDLIST::NextCurrent</a></div><div class="ttdeci">void NextCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00085">Chain.hpp:85</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a9376873ee15cd2ad4f239b832c700c56"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">CMDRSCHAINEDLIST::AddItem</a></div><div class="ttdeci">void AddItem(T *inpt)</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00061">Chain.hpp:61</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_ae382ce65496e09ba16dfa0fc6f311a27"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">CMDRSCHAINEDLIST::pCurrentItem</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pCurrentItem</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00039">Chain.hpp:39</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST</a></div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00033">Chain.hpp:33</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_a57edf0e3c4df958d02e9ef2d8af67c05"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">CMDRSCHAINEDLISTITEM::pNext</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM * pNext</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00013">Chain.hpp:13</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a604e8c770db9bc2a7b11fa2aacc56993"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">CMDRSCHAINEDLIST::pFirst</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pFirst</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00037">Chain.hpp:37</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_aa4dd9b25f2fb55a906a2b052979e9cf2"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">CMDRSCHAINEDLISTITEM::Obj</a></div><div class="ttdeci">T * Obj</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00011">Chain.hpp:11</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a6a8536f2cb62714624e8a1ae2c021191"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a6a8536f2cb62714624e8a1ae2c021191">CMDRSCHAINEDLIST::CMDRSCHAINEDLIST</a></div><div class="ttdeci">CMDRSCHAINEDLIST()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00042">Chain.hpp:42</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a></div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00007">Chain.hpp:7</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Chain.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
